;Tip1795:   avtx.lsp           add vertex to polyline         (c)2002, Aniyam Kandiyil

;;;adds vertex to a polyline/viewport
  
;;amended to work with Bricscad viewports - Brad McCurtayne, AddtoCad.com.au

;;;================================================

(defun c:Edit_Vertex (/ old_osmode cr_lyr pl_lst  pl_wid xd_lst  pl_opn pl_lyr  pc_pnt pk_pnt
                    nr_pnt midpnt  sp lp  ne_pnt en_pnt an_mid en_pnt1   en_pnt en_pnt2
                    vtx_lst cnt  obj_lst nvtx_lst start_pt end_pt  pl_ent pk_pln  item cnt1
                    cnt2 pos bulge option ent_lgth npt_lst pl_type vp_ent
                 ) ;_ end of /

  (vl-load-com)

  (initget "Add Remove Bulge Nobulge")
  (setq option (getkword "Select an Edit Vertex option : [Add / Remove / Bulge / Nobulge] <Add> : "))

  (if (= option nil)
    (setq option "Add")
  ) ;_ end of if

  (setvar "CMDECHO" 0)

  (setq old_osmode (GETVAR "osmode")) ;_ end of setq

  (setvar "OSMODE" 0)

  (setq pk_pln (entsel "\nPick a polyline at the Vertex to edit :"))

  (setvar "OSMODE" old_osmode)

  (setq pl_ent (car pk_pln)
        pl_lst (entget pl_ent)
        pl_type (cdr (assoc 0 pl_lst))
  )

  (if (= pl_type "VIEWPORT")
    (progn
      (setq vp_ent pl_ent
	    pl_ent (cdr (assoc 340 pl_lst))
      ) ;_ end of setq
      (if (= pl_ent nil)
	(progn
	  (prompt "\nSorry, Non Polygonal Viewports are not supported.")
	  (exit)
	  (princ)
	) ;_ end of progn
	(setq pl_lst (entget pl_ent))
      ) ;_ end of if
    ) ;_ end of progn
  ) ;_ end of if

  (if (/= "LWPOLYLINE" (cdr (assoc 0 pl_lst)))
    (progn
      (Alert
        "ERROR : The selected object is not a polyline. \n\nNOTE : \n\n3D Polylines are not supported \n\n2D Polylines need to be converted to LW polyline. \n\nUse the CONVERTPOLY comand."
      ) ;_ end of Alert
      (exit)
      (princ)
    ) ;_ end of progn
  ) ;_ end of if
  
  (setq
        pl_wid (cdr (assoc 40 pl_lst))
        xd_lst (assoc -3 (entget (car pk_pln) (list "*")))
        pl_opn (cdr (assoc 70 pl_lst))  ; flag for open, curved fit etc
        pl_lyr (cdr (assoc 8 pl_lst))
        pc_pnt (cadr pk_pln)
        pk_pnt (osnap pc_pnt "mid")
        nr_pnt (osnap pc_pnt "nea")
        ne_pnt (list (car pk_pnt) (cadr pk_pnt))
        en_pnt (osnap pc_pnt "end")
        an_mid (angle pk_pnt en_pnt)
        en_pnt1 (list (car en_pnt) (cadr en_pnt))
        en_pnt (polar pk_pnt (+ an_mid pi) (distance pk_pnt en_pnt))
        en_pnt2 (list (car en_pnt) (cadr en_pnt))
        ent_lgth (length pl_lst)
        vtx_lst ()

    ;;need to save a list of the existing bulges so that these can be restored

  ) ;_ end of setq

  (if (or (= pl_opn 2) (= pl_opn 3) (= pl_opn 130) (= pl_opn 131))
    (progn
      (alert "Curve fit polylines not supported at this time. Chow") (exit) (princ)
    )
    (if (= pl_opn 5)
      (progn
        (alert "Spline fit polylines not supported at this time. Bye") (exit) (princ)
      )
      (if (= pl_opn 16)
        (progn
          (alert "Polygon Mesh not supported at this time. So long") (exit) (princ)
        )
      ) ;_ end of if
    ) ;_ end of if
  ) ;_ end of if

  (foreach  cnt   pl_lst
    (if (= (car cnt) 10)
      (setq vtx_lst (append vtx_lst (list (cdr cnt))))
    ) ;_ end of if
  ) ;_ end of foreach

  (rvs_vtx)  ;insert new point into vertex list

  ;; need to insert the new vertex in the existing entity list - PL_LST

  (setq cnt1 0  ;keep place in PT_LST
        cnt2 0
  )  ;count the vertex points

  (if (= pos nil)
    (progn
      (alert "Error : The Vertex position was not found")
      (exit)
      (princ)
    ) ;_ end of progn
  ) ;_ end of if

  (while (and (/= cnt2 pos)
              (< cnt1 (* 1.2 ent_lgth))
         ) ;_ end of and

    ;;read each item in the entity list
    (setq item (nth cnt1 pl_lst)
          cnt1 (1+ cnt1)
    ) ;_ end of setq

    ;;test to see if the first item is 10
    (if (= (car item) 10)
      (setq cnt2 (1+ cnt2))  ; if it is then add to vertex point counter
    ) ;_ end of if

  ) ;_ end of while

  (if (> cnt1 ent_lgth)      ;point to insert is at the end of the polyline
    (setq cnt1 ent_lgth)
  ) ;_ end of if

  (if (= option "Add")      ; add vertex option

    (progn

      ;;get the bulge value of the previous vertex so that it
      ;;can be continued on
      (setq bulge (cdr (nth (- cnt1 2) PL_LST)))

      ;;when it gets to the correct 10 position matching the POS variable
      ;;insert the new list items for the new point

      (setq cnt1 (1- cnt1)
            npt_lst (ins_before cnt1 (cons 42 bulge) pl_lst)
            npt_lst (ins_before cnt1 (cons 41 pl_wid) npt_lst)
            npt_lst (ins_before cnt1 (cons 40 pl_wid) npt_lst)
            nr_pnt (list (car nr_pnt) (cadr nr_pnt))  ;change the format for poly
            npt_lst (ins_before cnt1 (cons 10 nr_pnt) npt_lst)
      ) ;_ end of setq

    ) ;_ end of progn

    (if (= option "Remove")            ;remove vertex option

      (progn

        ;;when it gets to the correct 10 position matching the pos variable
        ;;insert the new list items for the new point

        (setq cnt1 (1- cnt1)
              npt_lst (remove_nth cnt1 pl_lst)
              npt_lst (remove_nth cnt1 npt_lst)
              npt_lst (remove_nth cnt1 npt_lst)
              npt_lst (remove_nth cnt1 npt_lst)
              npt_lst (ins_before cnt1 (cons 42 0.0) npt_lst)
              npt_lst (remove_nth (1- cnt1) npt_lst)
        ) ;_ end of setq
      ) ;_ end of progn

      (if (= option "Bulge")          ;add bulge to vertex option
        (progn
          (setq cnt1 (1- cnt1)
                npt_lst (remove_nth cnt1 pl_lst)
                npt_lst (ins_before cnt1 (cons 42 -0.3) pl_lst)
          ) ;_ end of setq
        ) ;_ end of progn

        (if (= option "Nobulge")     ;remove bulge option

          (progn
            (setq cnt1 (- cnt1 3)
                  npt_lst (remove_nth cnt1 pl_lst)
                  npt_lst (ins_before cnt1 (cons 42 0.0) npt_lst)
            ) ;_ end of setq
          ) ;_ end of progn

          (if (= option "Flip_Blg")  ;remove bulge option

            (progn
              (setq cnt1 (- cnt1 2)
                    bulge (- 0 (cdr (nth cnt1 PL_LST)))
                    npt_lst (remove_nth cnt1 pl_lst)
                    npt_lst (ins_before cnt1 (cons 42 bulge) npt_lst)
              ) ;_ end of setq
            ) ;_ end of progn

          ) ;_ end of if

        ) ;_ end of if

      ) ;_ end of if
    ) ;_ end of if

  )

  ;;modify polyline using the edited entity list
  (entmod npt_lst)

  (if (=  option "Add")
     (command "stretch" "c" nr_pnt nr_pnt "" nr_pnt)
  )

  (princ)
) ;_ end of defun


;;;;=========================
(defun rvs_vtx ()

  (setq nvtx_lst ())
  (setq cnt 0)
  (setq start_pt (nth cnt vtx_lst))  ;get the start point
  (setq end_pt (nth (+ cnt 1) vtx_lst))     ; get the endpoint

  (while (and start_pt end_pt)
    (progn

      (if (not (member start_pt nvtx_lst))  ;if its not in the new vertex list
        (setq nvtx_lst (append nvtx_lst (list start_pt)))  ;add it in
      ) ;_ end of if

      (fmidp start_pt end_pt)  ;;see function below to find mid point

      (if (and (not (member nr_pnt nvtx_lst))
            ;;check to see if the distance to each endpoint is equal
               (= (rtos (distance pk_pnt start_pt) 2 4) (rtos (distance pk_pnt end_pt) 2 4))
          ) ;_ end of and
        (progn
          (setq nvtx_lst (append nvtx_lst (list nr_pnt))
            ;;insert the new point here
                pos (length nvtx_lst)
                ;;this is used to get the point position in the list
          ) ;_ end of setq
          ;;now that we have the correct vertex we can work out which end it is closer to
          (if (= option "Remove")
            ;;remove vertex option
            (progn
              (if (< (distance nr_pnt start_pt) (distance nr_pnt end_pt))
                (setq pos (1- pos))
              ) ;_ end of if
            ) ;_ end of progn
          ) ;_ end of if
        ) ;_ end of progn
      ) ;_ end of if

      (if (not (equal start_pt end_pt))
        (setq nvtx_lst (append nvtx_lst (list end_pt)))
      ) ;_ end of if

      (setq cnt (+ cnt 1))
      (setq start_pt (nth cnt vtx_lst))

      (if (not (setq end_pt (nth (+ cnt 1) vtx_lst)))
        (progn
          (if (not (member nr_pnt nvtx_lst))
            (setq nvtx_lst (append nvtx_lst (list nr_pnt))  ;;insert the new point here
                  pos (length nvtx_lst)
            ) ;_ end of setq
          ) ;_ end of if
          (setq start_pt nil)
        ) ;_ end of progn
      ) ;_ end of if
    )  ;progn
  )    ;while

) ;_ end of defun

;;;----------------------------------

;;OK Kenny, now we give in. HOW do you calculate a bulge ?

;;;;Bulge = TAN ( / Included Angle 4)

;;;In our case Bulge = TAN ( / 90 4) = 0.4142

;;;----------------------------------


(defun fmidp (sp lp)  ;;find mid point
  (setq midpnt (list (/ (+ (car sp) (car lp)) 2.0)
                     (/ (+ (cadr sp) (cadr lp)) 2.0)
               ) ;_ end of list
  ) ;_ end of setq
) ;_ end of defun


;;; ----------------------- Ins_Before.lsp -----------------------------

;;; Function inserts item before number specified in list. If number is
;;; invalid, the original list is returned.

;;; Base 0

;;; Written by Larry Leuallen 09-17-94
;;; Copyright 1994. Larry Leuallen. All rights reserved.

(defun ins_before (num item lst / split_at nlst)
  (defun split_at (num lst / head tail cnt)
    (setq cnt 0
          num (1+ num)
    )
    (cond
      ((and (>= num 1) (<= num (length lst)))
        (while (>= (length lst) cnt)
          (cond
            ((< cnt num)
                (setq head (cons (nth cnt lst) head))
            )
            ((>= cnt num)
                 (setq tail (cons (nth cnt lst) tail))
            )
          )
          (setq cnt (1+ cnt))
        )
         (list (reverse head) (reverse (cdr tail)))
      )
      (t
        lst
      )
    )  ; end cond.
  )    ; end defun
  (setq num (1- num))
  (cond
    ((and (>= num 0) (< num (1- (length lst))))
          (setq nlst (split_at num lst))
          (append (car nlst) (list item) (cadr nlst))
    )
    (t
      lst
    )
  )    ; end cond.
)      ;end defun

;;;-------------------------- Remove_Nth.lsp ---------------------------

;;; Removes the nth element from a list. Counting base is 0. If
;;; number is invalid for length of list, the original list is
;;; returned.

;;; Written by Larry Leuallen 09-17-94.
;;; Copyright 1994. Larry Leuallen. All rights reserved.

(defun remove_nth (num lst / split_list head tail cnt)
  (setq cnt 0
        num (1+ num)
  )
  (cond
    ((and (>= num 1) (<= num (length lst)))
      (while (>= (length lst) cnt)
        (cond
          ((< cnt num)
              (setq head (cons (nth cnt lst) head))
          )
          ((>= cnt num)
               (setq tail (cons (nth cnt lst) tail))
          )
        )
        (setq cnt (1+ cnt))
      )
       (setq split_list (list (reverse head) (reverse (cdr tail))))
       (append (reverse (cdr (reverse (car split_list)))) (cadr split_list))
    )
    (t
      lst
    )
  )    ; end cond.
)      ;end defun


;;-----------------------------------------------------------

(prompt "\n \nPolyline/Viewport Vertex Commands loaded. \nType Edit_Vertex to run.")
(princ)

